# frozen_string_literal: true

# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Auto-generated by gapic-generator-ruby. DO NOT EDIT!

require "gapic/common"
require "gapic/config"
require "gapic/config/method"

require "google/cloud/spanner/v1/version"

require "google/cloud/spanner/v1/spanner/credentials"
require "google/cloud/spanner/v1/spanner/paths"
require "google/cloud/spanner/v1/spanner/client"

module Google
  module Cloud
    module Spanner
      module V1
        ##
        # Cloud Spanner API
        #
        # The Cloud Spanner API can be used to manage sessions and execute
        # transactions on data stored in Cloud Spanner databases.
        #
        # @example Load this service and instantiate a gRPC client
        #
        #     require "google/cloud/spanner/v1/spanner"
        #     client = ::Google::Cloud::Spanner::V1::Spanner::Client.new
        #
        module Spanner
        end
      end
    end
  end
end

helper_path = ::File.join __dir__, "spanner", "helpers.rb"
require "google/cloud/spanner/v1/spanner/helpers" if ::File.file? helper_path
